/* ###################################################################
**     This component module is generated by Processor Expert. Do not modify it.
**     Filename    : ADC.c
**     Project     : ChargeurL200
**     Processor   : MC9S08SH8MPJ
**     Component   : Init_ADC
**     Version     : Component 01.244, Driver 01.20, CPU db: 3.00.067
**     Compiler    : CodeWarrior HCS08 C Compiler
**     Date/Time   : 2019-11-30, 12:30, # CodeGen: 19
**     Abstract    :
**          This file implements the ADC (ADC) module initialization 
**          according to the Peripheral Initialization Component settings, and defines
**          interrupt service routines prototypes. 

**     Settings    :
**          Component name                                 : ADC
**          Device                                         : ADC
**          Prescaler                                      : 4
**          Sample time                                    : 12.12 us
**          Conversion mode                                : Single conversion
**          Result data formats                            : 10-bit right
**          ADC Channels                                   : 2
**          Pins                                           : PTA0_PIA0_TPM1CH0_ADP0_ACMPPLUS
**                                                           PTA1_PIA1_TPM2CH0_ADP1_ACMPMINUS
**          Interrupt                                      : Vadc
**          Conversion complete interrupt                  : Disabled
**          ISR name                                       : 
**          Initial channel select                         : ADC Disabled
**          Call Init method                               : yes
**          Enable module                                  : Disabled

**     Contents    :
**         Init - void ADC_Init(void);
**
**     Copyright : 1997 - 2014 Freescale Semiconductor, Inc. 
**     All Rights Reserved.
**     
**     Redistribution and use in source and binary forms, with or without modification,
**     are permitted provided that the following conditions are met:
**     
**     o Redistributions of source code must retain the above copyright notice, this list
**       of conditions and the following disclaimer.
**     
**     o Redistributions in binary form must reproduce the above copyright notice, this
**       list of conditions and the following disclaimer in the documentation and/or
**       other materials provided with the distribution.
**     
**     o Neither the name of Freescale Semiconductor, Inc. nor the names of its
**       contributors may be used to endorse or promote products derived from this
**       software without specific prior written permission.
**     
**     THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
**     ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
**     WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
**     DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
**     ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
**     (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
**     LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
**     ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
**     (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
**     SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
**     
**     http: www.freescale.com
**     mail: support@freescale.com
** ###################################################################*/
/*!
** @file ADC.c
** @version 01.20
** @brief
**          This file implements the ADC (ADC) module initialization 
**          according to the Peripheral Initialization Component settings, and defines
**          interrupt service routines prototypes. 

*/         
/*!
**  @addtogroup ADC_module ADC module documentation
**  @{
*/         

/* MODULE ADC. */

#include "ADC.h"

/*
** ===================================================================
**     Method      :  ADC_Init (component Init_ADC)
**     Description :
**         This method initializes registers of the ADC module
**         according to this Peripheral Initialization Component settings.
**         Call this method in user code to initialize the module.
**         By default, the method is called by PE automatically; see
**         "Call Init method" property of the component for more details.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void ADC_Init(void)
{
  /* APCTL1: ADPC7=0,ADPC6=0,ADPC5=0,ADPC4=0,ADPC3=0,ADPC2=0,ADPC1=1,ADPC0=1 */
  setReg8(APCTL1, 0x03U);               
  /* ADCCFG: ADLPC=0,ADIV1=1,ADIV0=0,ADLSMP=0,MODE1=1,MODE0=0,ADICLK1=0,ADICLK0=0 */
  setReg8(ADCCFG, 0x48U);               
  /* ADCCV: ??=0,??=0,??=0,??=0,??=0,??=0,ADCV9=0,ADCV8=0,ADCV7=0,ADCV6=0,ADCV5=0,ADCV4=0,ADCV3=0,ADCV2=0,ADCV1=0,ADCV0=0 */
  setReg16(ADCCV, 0x00U);               
  /* ADCSC2: ADACT=0,ADTRG=0,ACFE=0,ACFGT=0,??=0,??=0,??=0,??=0 */
  setReg8(ADCSC2, 0x00U);               
  /* ADCSC1: COCO=0,AIEN=0,ADCO=0,ADCH4=1,ADCH3=1,ADCH2=1,ADCH1=1,ADCH0=1 */
  setReg8(ADCSC1, 0x1FU);               
}
/* END ADC. */

/*!
** @}
*/
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.3 [05.09]
**     for the Freescale HCS08 series of microcontrollers.
**
** ###################################################################
*/
