/* ###################################################################
**     Filename    : main.c
**     Project     : ChargeurL200
**     Processor   : MC9S08SH8MPJ
**     Version     : Driver 01.12
**     Compiler    : CodeWarrior HCS08 C Compiler
**     Date/Time   : 2019-07-01, 13:58, # CodeGen: 0
**     Abstract    :
**         Main module.
**         This module contains user's application code.
**     Settings    :
**     Contents    :
**         No public methods
**
** ###################################################################*/
/*!
** @file main.c
** @version 01.12
** @brief
**         Main module.
**         This module contains user's application code.
*/         
/*!
**  @addtogroup main_module main module documentation
**  @{
*/         
/* MODULE main */


/* Including needed modules to compile this module/procedure */
#include "Cpu.h"
#include "Events.h"
#include "COPFree.h"
#include "I2C.h"
#include "BKL.h"
#include "Charge.h"
#include "CmdBLK.h"
#include "ADC.h"
#include "TI1.h"
/* Include shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"

/* User includes (#include below this line is not maintained by Processor Expert) */
#include "delai_tpm.h"
#include "AffI2C_RW1063.h"
#include "conversion_AN.h"
#include "Routine_Conv_Bin-ASCII.h"

uint16_t mesI, mesU;
uint32_t calcul;
char chaine[6], BKLon = 0;
uint8_t valU[2];
volatile uint8_t ask4mesU;
volatile uint32_t millis;
uint32_t timeBLK, timeMes;
void main(void)
{
  /* Write your local variable definition here */

  /*** Processor Expert internal initialization. DON'T REMOVE THIS CODE!!! ***/
  PE_low_level_init();
  /*** End of Processor Expert internal initialization.                    ***/
  Charge_ClrVal();
  CmdBLK_ClrVal();
  init_LCD();
  init_time();
  ask4mesU = 0;
  write_msg("Chargeur batterie");
  locate(0,1);		//Line 2
  write_msg("Solaire L200 10Ah");
  Delay_ms(2000);
  clrscr();
  timeMes = millis;
  for(;;) {
	  if(BKL_GetVal()==0) {
		  CmdBLK_SetVal();
		  BKLon = 1;
		  timeBLK = millis;
	  }
	  if(BKLon==1&&(millis - timeBLK)>1500) {
		  CmdBLK_ClrVal();
		  BKLon = 0;
	  }
  
	  if((millis - timeMes)>=2000){
		  I2C_SetMode(TRUE);//mode maitre
		  mesU = get_conv(1);
		  calcul = (uint32_t)mesU * 156;
		  mesU = calcul/10;
		  if(mesU<11500) Charge_ClrVal();
		  if(mesU>11800) Charge_SetVal();
		  convBinAscii(mesU, chaine);
		  locate(0,0);		//Line 1
		  write_msg("Ubat= ");
		  write_msg(chaine);
		  write_msg(" mV");
		  mesI = (get_conv(0)-8);
		  convBinAscii(mesI, chaine);
		  locate(0,1);		//Line 2
		  write_msg("Ich= ");
		  write_msg(chaine);
		  write_msg(" mA");
		  I2C_SetMode(FALSE);//mode esclave
		  valU[0] = (uint8_t)mesU;
		  valU[1] = (uint8_t)(mesU>>8);
		  I2C_SendBlock(valU,2,chaine);
		  timeMes = millis;
	  }
		  
	  if(ask4mesU){
		  //I2C_SetMode(FALSE);
		  
		  ask4mesU = 0;
	  }
  }

  /*** Don't write any code pass this line, or it will be deleted during code generation. ***/
  /*** RTOS startup code. Macro PEX_RTOS_START is defined by the RTOS component. DON'T MODIFY THIS CODE!!! ***/
  #ifdef PEX_RTOS_START
    PEX_RTOS_START();                  /* Startup of the selected RTOS. Macro is defined by the RTOS component. */
  #endif
  /*** End of RTOS startup code.  ***/
  /*** Processor Expert end of main routine. DON'T MODIFY THIS CODE!!! ***/
  for(;;){}
  /*** Processor Expert end of main routine. DON'T WRITE CODE BELOW!!! ***/
} /*** End of main routine. DO NOT MODIFY THIS TEXT!!! ***/

/* END main */
/*!
** @}
*/
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.3 [05.09]
**     for the Freescale HCS08 series of microcontrollers.
**
** ###################################################################
*/
