/* ###################################################################
**     This component module is generated by Processor Expert. Do not modify it.
**     Filename    : Cpu.c
**     Project     : ChargeurLT1513
**     Processor   : MC9S08PA16VWJ
**     Component   : MC9S08PA16_20
**     Version     : Component 01.105, Driver 01.40, CPU db: 3.00.000
**     Datasheet   : MC9S08PT16RM Rev. 0 Draft B, 10/2011
**     Compiler    : CodeWarrior HCS08 C Compiler
**     Date/Time   : 2019-09-30, 15:10, # CodeGen: 0
**     Abstract    :
**         This component "MC9S08PA16_20" contains initialization 
**         of the CPU and provides basic methods and events for 
**         CPU core settings.
**     Settings    :
**
**     Contents    :
**         EnableInt  - void Cpu_EnableInt(void);
**         DisableInt - void Cpu_DisableInt(void);
**         Delay100US - void Cpu_Delay100US(word us100);
**
**     Copyright : 1997 - 2014 Freescale Semiconductor, Inc. 
**     All Rights Reserved.
**     
**     Redistribution and use in source and binary forms, with or without modification,
**     are permitted provided that the following conditions are met:
**     
**     o Redistributions of source code must retain the above copyright notice, this list
**       of conditions and the following disclaimer.
**     
**     o Redistributions in binary form must reproduce the above copyright notice, this
**       list of conditions and the following disclaimer in the documentation and/or
**       other materials provided with the distribution.
**     
**     o Neither the name of Freescale Semiconductor, Inc. nor the names of its
**       contributors may be used to endorse or promote products derived from this
**       software without specific prior written permission.
**     
**     THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
**     ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
**     WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
**     DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
**     ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
**     (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
**     LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
**     ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
**     (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
**     SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
**     
**     http: www.freescale.com
**     mail: support@freescale.com
** ###################################################################*/
/*!
** @file Cpu.c
** @version 01.40
** @brief
**         This component "MC9S08PA16_20" contains initialization 
**         of the CPU and provides basic methods and events for 
**         CPU core settings.
*/         
/*!
**  @addtogroup Cpu_module Cpu module documentation
**  @{
*/         

/* MODULE Cpu. */

#pragma MESSAGE DISABLE C4002 /* WARNING C4002: Result not used is ignored */

#include "WDOG.h"
#include "SDWN.h"
#include "Charge.h"
#include "Ch_Ich.h"
#include "Tplus.h"
#include "Tmoins.h"
#include "Val.h"
#include "I2C.h"
#include "Timer_1ms.h"
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
#include "PE_Timer.h"
#include "Events.h"
#include "Cpu.h"


/* Global variables */
volatile byte CCR_reg;                 /* Current CCR register */
volatile byte CCR_lock;                /* Nesting level of critical regions */


/*
** ===================================================================
**     Method      :  Cpu_Interrupt (component MC9S08PA16_20)
**
**     Description :
**         The method services unhandled interrupt vectors.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
ISR(Cpu_Interrupt)
{
  /* This code can be changed using the CPU component property "Build Options / Unhandled int code" */
  /*lint -save -e950 Disable MISRA rule (1.1) checking. */
  asm(BGND);
  /*lint -restore Enable MISRA rule (1.1) checking. */
}


/*
** ===================================================================
**     Method      :  Cpu_DisableInt (component MC9S08PA16_20)
**     Description :
**         Disables maskable interrupts
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
/*
void Cpu_DisableInt(void)

**      This method is implemented as macro in the header module. **
*/

/*
** ===================================================================
**     Method      :  Cpu_EnableInt (component MC9S08PA16_20)
**     Description :
**         Enables maskable interrupts
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
/*
void Cpu_EnableInt(void)

**      This method is implemented as macro in the header module. **
*/

/*
** ===================================================================
**     Method      :  Cpu_Delay100US (component MC9S08PA16_20)
**     Description :
**         This method realizes software delay. The length of delay
**         is at least 100 microsecond multiply input parameter
**         [us100]. As the delay implementation is not based on real
**         clock, the delay time may be increased by interrupt
**         service routines processed during the delay. The method
**         is independent on selected speed mode.
**     Parameters  :
**         NAME            - DESCRIPTION
**         us100           - Number of 100 us delay repetitions.
**     Returns     : Nothing
** ===================================================================
*/
#pragma NO_ENTRY
#pragma NO_EXIT
#pragma MESSAGE DISABLE C5703
void Cpu_Delay100US(word us100)
{
  /* Total irremovable overhead: 16 cycles */
  /* ldhx: 5 cycles overhead (load parameter into register) */
  /* jsr:  5 cycles overhead (jump to subroutine) */
  /* rts:  6 cycles overhead (return from subroutine) */

  /* aproximate irremovable overhead for each 100us cycle (counted) : 8 cycles */
  /* aix:  2 cycles overhead  */
  /* cphx: 3 cycles overhead  */
  /* bne:  3 cycles overhead  */
  /*lint -save  -e950 -e522 Disable MISRA rule (1.1,14.2) checking. */
  asm {
loop:
    /* 100 us delay block begin */
    /*
     * Delay
     *   - requested                  : 100 us @ 8MHz,
     *   - possible                   : 800 c, 100000 ns
     *   - without removable overhead : 792 c, 99000 ns
     */
    pshh                               /* (2 c: 250 ns) backup H */
    pshx                               /* (2 c: 250 ns) backup X */
    ldhx #$0015                        /* (3 c: 375 ns) number of iterations */
label0:
    pshh                               /*(2 c: 250 ns) backup H before COP reset */
    pshx                               /* (2 c: 250 ns) backup X before COP reset */
    TPA
    SEI
    LDHX #-23038
    STHX WDOG_CNT
    LDHX #-19328
    STHX WDOG_CNT
    TAP
    pulx                               /* (2 c: 250 ns) restore X after COP reset */
    pulh                               /* (2 c: 250 ns) restore H after COP reset */
    aix #-1                            /* (2 c: 250 ns) decrement H:X */
    cphx #0                            /* (3 c: 375 ns) compare it to zero */
    bne label0                         /* (3 c: 375 ns) repeat 21x */
    pulx                               /* (3 c: 375 ns) restore X */
    pulh                               /* (3 c: 375 ns) restore H */
    nop                                /* (1 c: 125 ns) wait for 1 c */
    nop                                /* (1 c: 125 ns) wait for 1 c */
    /* 100 us delay block end */
    aix #-1                            /* us100 parameter is passed via H:X registers */
    cphx #0
    bne loop                           /* next loop */
    rts                                /* return from subroutine */
  }
  /*lint -restore Enable MISRA rule (1.1,14.2) checking. */
}

/*
** ===================================================================
**     Method      :  _EntryPoint (component MC9S08PA16_20)
**
**     Description :
**         Initializes the whole system like timing and so on. At the end 
**         of this function, the C startup is invoked to initialize stack,
**         memory areas and so on.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
extern void _Startup(void);            /* Forward declaration of external startup function declared in file Start12.c */

#pragma NO_FRAME
#pragma NO_EXIT
void _EntryPoint(void)
{
  /* ### MC9S08PA16_20 "Cpu" init code ... */
  /*  PE initialization code after reset */
  /* WDOG_CNT: CNT=0xC520 */
  setReg16(WDOG_CNT, 0xC520U);         /* First part of the WDG unlock sequence */ 
  /* WDOG_CNT: CNT=0xD928 */
  setReg16(WDOG_CNT, 0xD928U);         /* Second part of the WDG unlock sequence */ 
  /*  Initialization of Init_WDOG */
  /* WDOG_CS2: WIN=0,FLG=1,??=0,PRES=0,??=0,??=0,CLK=1 */
  setReg8(WDOG_CS2, 0x41U);             
  /* WDOG_CS1: EN=0,INT=0,UPDATE=0,TST=0,DBG=0,WAIT=0,STOP=0 */
  setReg8(WDOG_CS1, 0x00U);             
  /* WDOG_TOVAL: TOVAL=4 */
  setReg16(WDOG_TOVAL, 0x04U);          
  /* WDOG_WIN: WIN=0 */
  setReg16(WDOG_WIN, 0x00U);            
  /* Common initialization of the write once registers */
  /* SYS_SOPT1: IICPS=0,BKGDPE=1,RSTPE=1,FWAKE=0,STOPE=0 */
  clrSetReg8Bits(SYS_SOPT1, 0x23U, 0x0CU); 
  /* PMC_SPMSC1: LVWIE=0,LVDRE=1,LVDSE=1,LVDE=1,BGBDS=0,BGBE=0 */
  clrSetReg8Bits(PMC_SPMSC1, 0x23U, 0x1CU); 
  /* PMC_SPMSC2: LVDV=0,LVWV=0 */
  clrReg8Bits(PMC_SPMSC2, 0x70U);       
  /*  System clock initialization */
  /*lint -save  -e923 Disable MISRA rule (11.3) checking. */
  if (*(uint8_t*)0xFF6FU != 0xFFU) {   /* Test if the device trim value is stored on the specified address */
    ICS_C3 = *(uint8_t*)0xFF6FU;       /* Initialize ICS_C3 register from a non volatile memory */
    ICS_C4 = (uint8_t)((*(uint8_t*)0xFF6EU) & (uint8_t)0x01U); /* Initialize ICS_C4 register from a non volatile memory */
  }
  /*lint -restore Enable MISRA rule (11.3) checking. */
  /* ICS_C1: CLKS=0,RDIV=0,IREFS=1,IRCLKEN=1,IREFSTEN=0 */
  setReg8(ICS_C1, 0x06U);              /* Initialization of the ICS control register 1 */ 
  /* ICS_C2: BDIV=1,LP=0,??=0,??=0,??=0,??=0 */
  setReg8(ICS_C2, 0x20U);              /* Initialization of the ICS control register 2 */ 
  /* ICS_C4: LOLIE=0,CME=0 */
  clrReg8Bits(ICS_C4, 0xA0U);           

  /*** End of PE initialization code after reset ***/
  /*lint -save  -e950 Disable MISRA rule (1.1) checking. */
  __asm   jmp _Startup ;               /* Jump to C startup code */
  /*lint -restore Enable MISRA rule (1.1) checking. */
}

/*
** ===================================================================
**     Method      :  PE_low_level_init (component MC9S08PA16_20)
**
**     Description :
**         Initializes components and provides common register 
**         initialization. The method is called automatically as a part 
**         of the application initialization code.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
void PE_low_level_init(void)
{
  #ifdef PEX_RTOS_INIT
    PEX_RTOS_INIT();                   /* Initialization of the selected RTOS. Macro is defined by the RTOS component. */
  #endif
  /* SCG_C1: FTM2=1,??=0,FTM0=1,??=0,??=0,??=0,MTIM0=1,RTC=1 */
  setReg8(SCG_C1, 0xA3U);               
  /* SCG_C2: ??=0,??=0,DBG=1,NVM=1,IPC=1,CRC=1,??=0,??=0 */
  setReg8(SCG_C2, 0x3CU);               
  /* SCG_C3: ??=0,??=0,SCI1=1,SCI0=1,??=0,SPI0=1,IIC=1,??=0 */
  setReg8(SCG_C3, 0x36U);               
  /* SCG_C4: ACMP=1,??=0,ADC=1,??=0,IRQ=1,??=0,??=0,KBI0=1 */
  setReg8(SCG_C4, 0xA9U);               
  /* Common initialization of the CPU registers */
  /* PORT_PTAD: PTAD1=1,PTAD0=1 */
  setReg8Bits(PORT_PTAD, 0x03U);        
  /* PORT_PTAPE: PTAPE1=0 */
  clrReg8Bits(PORT_PTAPE, 0x02U);       
  /* PORT_PTAOE: PTAOE1=1,PTAOE0=1 */
  setReg8Bits(PORT_PTAOE, 0x03U);       
  /* PORT_PTAIE: PTAIE1=0 */
  clrReg8Bits(PORT_PTAIE, 0x02U);       
  /* PORT_PTBD: PTBD2=0 */
  clrReg8Bits(PORT_PTBD, 0x04U);        
  /* PORT_PTBPE: PTBPE7=1,PTBPE6=1,PTBPE5=1,PTBPE2=0 */
  clrSetReg8Bits(PORT_PTBPE, 0x04U, 0xE0U); 
  /* PORT_PTBOE: PTBOE7=0,PTBOE6=0,PTBOE5=0,PTBOE2=1 */
  clrSetReg8Bits(PORT_PTBOE, 0xE0U, 0x04U); 
  /* PORT_PTBIE: PTBIE7=1,PTBIE6=1,PTBIE5=1,PTBIE2=0 */
  clrSetReg8Bits(PORT_PTBIE, 0x04U, 0xE0U); 
  /* SYS_SOPT3: FTM0PS=0,CLKOE=0,BUSREF=0 */
  clrReg8Bits(SYS_SOPT3, 0x4FU);        
  /* IPC_ILRS9: ILRn3=0,ILRn2=0,ILRn1=0,ILRn0=0 */
  setReg8(IPC_ILRS9, 0x00U);            
  /* IPC_ILRS8: ILRn3=0,ILRn2=0,ILRn1=0,ILRn0=0 */
  setReg8(IPC_ILRS8, 0x00U);            
  /* IPC_ILRS7: ILRn3=0,ILRn2=0,ILRn1=0,ILRn0=0 */
  setReg8(IPC_ILRS7, 0x00U);            
  /* IPC_ILRS6: ILRn3=0,ILRn2=0,ILRn1=0,ILRn0=0 */
  setReg8(IPC_ILRS6, 0x00U);            
  /* IPC_ILRS5: ILRn3=0,ILRn2=0,ILRn1=0,ILRn0=0 */
  setReg8(IPC_ILRS5, 0x00U);            
  /* IPC_ILRS4: ILRn3=0,ILRn2=0,ILRn1=0,ILRn0=0 */
  setReg8(IPC_ILRS4, 0x00U);            
  /* IPC_ILRS3: ILRn3=0,ILRn2=0,ILRn1=0,ILRn0=0 */
  setReg8(IPC_ILRS3, 0x00U);            
  /* IPC_ILRS2: ILRn3=0,ILRn2=0,ILRn1=0,ILRn0=0 */
  setReg8(IPC_ILRS2, 0x00U);            
  /* IPC_ILRS1: ILRn3=0,ILRn2=2,ILRn1=0,ILRn0=0 */
  setReg8(IPC_ILRS1, 0x20U);            
  /* IPC_ILRS0: ILRn3=0,ILRn2=0,ILRn1=0,ILRn0=0 */
  setReg8(IPC_ILRS0, 0x00U);            
  /* IPC_SC: IPCE=1,??=0,PSE=0,PSF=0,PULIPM=0,??=0,IPM=0 */
  setReg8(IPC_SC, 0x80U);               
      /* Initialization of the PORT module */
  /* ### Shared modules init code ... */
  /* ### Init_WDOG "WDOG" init code ... */
  WDOG_Init();
  /* ### BitIO "SDWN" init code ... */
  /* ### BitIO "Charge" init code ... */
  /* ### Programable pulse generation "Ch_Ich" init code ... */
  Ch_Ich_Init();
  /* ### BitIO "Tplus" init code ... */
  /* ### BitIO "Tmoins" init code ... */
  /* ### BitIO "Val" init code ... */
  /* ### Init_IIC "I2C" init code ... */
  I2C_Init();
  /* ### TimerInt "Timer_1ms" init code ... */
  Timer_1ms_Init();
  CCR_lock = (byte)0;
  __EI();                              /* Enable interrupts */
}

/*lint -save  -e950 Disable MISRA rule (1.1) checking. */
/* Initialization of the CPU registers in FLASH */
/*lint -restore Enable MISRA rule (1.1) checking. */

/* END Cpu. */

/*!
** @}
*/
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.3 [05.09]
**     for the Freescale HCS08 series of microcontrollers.
**
** ###################################################################
*/
