/* ###################################################################
**     This component module is generated by Processor Expert. Do not modify it.
**     Filename    : I2C.h
**     Project     : ChargeurLT1513
**     Processor   : MC9S08PA16VWJ
**     Component   : Init_IIC
**     Version     : Component 01.081, Driver 01.20, CPU db: 3.00.000
**     Compiler    : CodeWarrior HCS08 C Compiler
**     Date/Time   : 2019-11-30, 12:31, # CodeGen: 5
**     Abstract    :
**          This file implements the IIC (I2C) module initialization
**          according to the Peripheral Initialization Component settings, and defines
**          interrupt service routines prototypes.
**          The inter-integrated circuit (IIC) interface is a two wire, bidirectional 
**          serial bus which provides a simple, efficient way for data exchange between 
**          devices. The interface is designed for internal serial communication between
**          the MCU and other IIC devices.
**     Settings    :
**          Component name                                 : I2C
**          Device                                         : I2C
**          Settings                                       : 
**          Clock settings                                 : 
**          Multiplier Factor                              : 4
**          Clock rate                                     : 0
**          SCL frequency                                  : 100 kHz
**          SDA Hold                                       : 3.5 us
**          Address                                        : 50
**          Transfer direction                             : Receive
**          Transmit Acknowledge                           : yes
**          Pins                                           : 
**          SDA pin                                        : PTA2_KBI0P2_RXD0_SDA
**          SDA pin signal                                 : 
**          SCL pin                                        : PTA3_KBI0P3_TXD0_SCL
**          SCL pin signal                                 : 
**          Interrupts                                     : 
**          Interrupt                                      : Viic
**          IIC interrupt                                  : Disabled
**          ISR name                                       : 
**          Initialization                                 : 
**          Call Init method                               : yes
**          Module Enable                                  : yes
**     Contents    :
**         Init - void I2C_Init(void);
**
**     Copyright : 1997 - 2014 Freescale Semiconductor, Inc. 
**     All Rights Reserved.
**     
**     Redistribution and use in source and binary forms, with or without modification,
**     are permitted provided that the following conditions are met:
**     
**     o Redistributions of source code must retain the above copyright notice, this list
**       of conditions and the following disclaimer.
**     
**     o Redistributions in binary form must reproduce the above copyright notice, this
**       list of conditions and the following disclaimer in the documentation and/or
**       other materials provided with the distribution.
**     
**     o Neither the name of Freescale Semiconductor, Inc. nor the names of its
**       contributors may be used to endorse or promote products derived from this
**       software without specific prior written permission.
**     
**     THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
**     ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
**     WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
**     DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
**     ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
**     (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
**     LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
**     ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
**     (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
**     SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
**     
**     http: www.freescale.com
**     mail: support@freescale.com
** ###################################################################*/
/*!
** @file I2C.h
** @version 01.20
** @brief
**          This file implements the IIC (I2C) module initialization
**          according to the Peripheral Initialization Component settings, and defines
**          interrupt service routines prototypes.
**          The inter-integrated circuit (IIC) interface is a two wire, bidirectional 
**          serial bus which provides a simple, efficient way for data exchange between 
**          devices. The interface is designed for internal serial communication between
**          the MCU and other IIC devices.
*/         
/*!
**  @addtogroup I2C_module I2C module documentation
**  @{
*/         

#ifndef __I2C
#define __I2C

/* MODULE I2C. */

/*Include shared modules, which are used for whole project*/
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
#include "PE_Timer.h"
/* Include inherited components */

#include "Cpu.h"

void I2C_Init(void);
/*
** ===================================================================
**     Method      :  I2C_Init (component Init_IIC)
**     Description :
**         This method initializes registers of the IIC module
**         according to this Peripheral Initialization Component settings.
**         Call this method in user code to initialize the module.
**         By default, the method is called by PE automatically; see
**         "Call Init method" property of the component for more details.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/

/* END I2C. */

#endif /* ifndef __I2C */
/*!
** @}
*/
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.3 [05.09]
**     for the Freescale HCS08 series of microcontrollers.
**
** ###################################################################
*/
