/* ###################################################################
**     This component module is generated by Processor Expert. Do not modify it.
**     Filename    : Timer_1ms.c
**     Project     : ChargeurLT1513
**     Processor   : MC9S08PA16VWJ
**     Component   : TimerInt
**     Version     : Component 02.161, Driver 01.23, CPU db: 3.00.000
**     Compiler    : CodeWarrior HCS08 C Compiler
**     Date/Time   : 2019-09-30, 15:10, # CodeGen: 0
**     Abstract    :
**         This component "TimerInt" implements a periodic interrupt.
**         When the component and its events are enabled, the "OnInterrupt"
**         event is called periodically with the period that you specify.
**         TimerInt supports also changing the period in runtime.
**         The source of periodic interrupt can be timer compare or reload
**         register or timer-overflow interrupt (of free running counter).
**     Settings    :
**         Timer name                  : FTM2 (16-bit)
**         Compare name                : FTM20
**         Counter shared              : No
**
**         High speed mode
**             Prescaler               : divide-by-1
**             Clock                   : 4000000 Hz
**           Initial period/frequency
**             Xtal ticks              : 31
**             microseconds            : 1000
**             milliseconds            : 1
**             seconds (real)          : 0.001
**             Hz                      : 1000
**             kHz                     : 1
**
**         Runtime setting             : none
**
**         Initialization:
**              Timer                  : Enabled
**              Events                 : Enabled
**
**         Timer registers
**              Counter                : FTM2_CNT  [$30C1]
**              Mode                   : FTM2_SC   [$30C0]
**              Run                    : FTM2_SC   [$30C0]
**              Prescaler              : FTM2_SC   [$30C0]
**
**         Compare registers
**              Compare                : FTM2_C0V  [$30C6]
**
**         Flip-flop registers
**              Mode                   : FTM2_C0SC [$30C5]
**     Contents    :
**         No public methods
**
**     Copyright : 1997 - 2014 Freescale Semiconductor, Inc. 
**     All Rights Reserved.
**     
**     Redistribution and use in source and binary forms, with or without modification,
**     are permitted provided that the following conditions are met:
**     
**     o Redistributions of source code must retain the above copyright notice, this list
**       of conditions and the following disclaimer.
**     
**     o Redistributions in binary form must reproduce the above copyright notice, this
**       list of conditions and the following disclaimer in the documentation and/or
**       other materials provided with the distribution.
**     
**     o Neither the name of Freescale Semiconductor, Inc. nor the names of its
**       contributors may be used to endorse or promote products derived from this
**       software without specific prior written permission.
**     
**     THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
**     ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
**     WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
**     DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
**     ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
**     (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
**     LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
**     ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
**     (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
**     SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
**     
**     http: www.freescale.com
**     mail: support@freescale.com
** ###################################################################*/
/*!
** @file Timer_1ms.c
** @version 01.23
** @brief
**         This component "TimerInt" implements a periodic interrupt.
**         When the component and its events are enabled, the "OnInterrupt"
**         event is called periodically with the period that you specify.
**         TimerInt supports also changing the period in runtime.
**         The source of periodic interrupt can be timer compare or reload
**         register or timer-overflow interrupt (of free running counter).
*/         
/*!
**  @addtogroup Timer_1ms_module Timer_1ms module documentation
**  @{
*/         

/* MODULE Timer_1ms. */

#include "Events.h"
#include "PE_Error.h"
#include "Timer_1ms.h"
#pragma MESSAGE DISABLE C2705          /* WARNING C2705: Possible loss of data */
#pragma MESSAGE DISABLE C5919          /* WARNING C5919: Conversion of floating to unsigned integral */
#pragma MESSAGE DISABLE C5703          /* WARNING C5703: Parameter X declared in function F but not referenced */
#pragma MESSAGE DISABLE C4002          /* Disable warning C4002 "Result not used" */

/*** Internal macros and method prototypes ***/

/*
** ===================================================================
**     Method      :  SetCV (component TimerInt)
**
**     Description :
**         The method computes and sets compare eventually modulo value 
**         for time measuring.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
#define Timer_1ms_SetCV(_Val) ( \
  FTM2_MOD = (FTM2_C0V = (word)(_Val)) )


/*** End of internal method prototypes ***/

/*
** ===================================================================
**     Method      :  Timer_1ms_Init (component TimerInt)
**
**     Description :
**         Initializes the associated peripheral(s) and the component 
**         internal variables. The method is called automatically as a 
**         part of the application initialization code.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
void Timer_1ms_Init(void)
{
  /* FTM2_MODE: FAULTIE=0,FAULTM=0,CAPTEST=0,PWMSYNC=0,WPDIS=1,INIT=0,FTMEN=0 */
  setReg8(FTM2_MODE, 0x04U);           /* Set TPM compatibility */ 
  /* FTM2_SC: TOF=0,TOIE=0,CPWMS=0,CLKS=0,PS=0 */
  setReg8(FTM2_SC, 0x00U);             /* Stop HW; disable overflow interrupt and set prescaler to 0 */ 
  /* FTM2_C0SC: CHF=0,CHIE=1,MSB=0,MSA=1,ELSB=0,ELSA=0,??=0,??=0 */
  setReg8(FTM2_C0SC, 0x50U);           /* Set output compare mode and enable compare interrupt */ 
  Timer_1ms_SetCV(0x0F9FU);            /* Initialize appropriate value to the compare/modulo/reload register */
  /* FTM2_CNTH: COUNT_H=0 */
  setReg8(FTM2_CNTH, 0x00U);           /* Reset HW Counter */ 
  /* FTM2_SC: TOF=0,TOIE=0,CPWMS=0,CLKS=1,PS=0 */
  setReg8(FTM2_SC, 0x08U);             /* Set prescaler and run counter */ 
}


/*
** ===================================================================
**     Method      :  Timer_1ms_Interrupt (component TimerInt)
**
**     Description :
**         The method services the interrupt of the selected peripheral(s)
**         and eventually invokes the component event(s).
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
ISR(Timer_1ms_Interrupt)
{
  /* FTM2_C0SC: CHF=0 */
  clrReg8Bits(FTM2_C0SC, 0x80U);       /* Reset compare interrupt request flag */ 
  Timer_1ms_OnInterrupt();             /* Invoke user event */
  IPC_SC_PULIPM = 1U;                  /* Restore Interrupt Priority Mask */
}



/* END Timer_1ms. */

/*!
** @}
*/
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.3 [05.09]
**     for the Freescale HCS08 series of microcontrollers.
**
** ###################################################################
*/
