/*
 * MPL311A2.c
 *
 *  Created on: 22 sept. 2019
 *      Author: Dominique
 */


#include "MPL3115A2.h"

	uint16_t _SlaveA = 0xC0;	//local variable that holds the Slave Address
	uint8_t _SensorData[8];  	//Char array that holds the current Altitude and Temperature data
	I2C_HandleTypeDef hi2c1;

	int MPL_Write_Register (uint8_t regnum, uint8_t data)   //Used for writing data to the MPL3115A2 Registers
	{
		uint8_t Write_Data[2];
		Write_Data[0] = regnum;
		Write_Data[1] = data;
		return(HAL_I2C_Master_Transmit(&hi2c1, _SlaveA, Write_Data, 2, 100));
	}

	int MPL_Read_MPL_Data(void)		//Read Data Register from MPL3115A2 Sensor
	{
		uint16_t Start_Register = {0x01};
		return(HAL_I2C_Mem_Read(&hi2c1, _SlaveA, Start_Register, I2C_MEMADD_SIZE_8BIT, _SensorData, 5,1000));

	}
	uint8_t MPL_Read_MPL_reg(uint8_t Register)		//Read Register from MPL3115A2 Sensor
		{
			uint8_t Data[2];
			Data[0] = Register;
			Data[1] = 0;
			//(void)(HAL_I2C_Master_Transmit(&hi2c1, _SlaveA, Data, 1, 100));
			//HAL_I2C_Master_Receive(&hi2c1, _SlaveA, Data, 1,100);
			HAL_I2C_Mem_Read(&hi2c1, _SlaveA, Register, I2C_MEMADD_SIZE_8BIT, Data, 1,100);
			return(Data[0]);
		}

	/*bool MPL_get_int1 (void)   //Return state of Int1 pin
	{
		return(_pin1.read());
	}

	bool MPL_get_int2 ()	  //Return state of Int2 pin
	{
		return(_pin2.read());
	}*/
	float MPL_Pressure(void) //Return Pressure in Pascal
	{
		uint8_t sta = 0;
		while (MPL_Read_MPL_reg(0x26) & 0x02) HAL_Delay(10);// Read the ost bit
		MPL_Write_Register(0x26,0x3A);  //initiate a measurement immediately in barometer mode
		while(!(sta & 0x04)){			//wait for valid pressure data
			sta = MPL_Read_MPL_reg(0);//Read the status register
		}
		HAL_I2C_Mem_Read(&hi2c1, _SlaveA, 0x01, I2C_MEMADD_SIZE_8BIT, _SensorData, 3,1000);
		return((((_SensorData[2]>>6)/4.0) + (_SensorData[0]*1024 + _SensorData[1])));
	}
	float MPL_Altitude_ft (void) //Return Altitude in Feet
	{
		uint8_t sta = 0;
		while (MPL_Read_MPL_reg(0x26) & 0x02) HAL_Delay(10);// Read the ost bit
		MPL_Write_Register(0x26,0xBA);  //initiate a measurement immediately in Altimeter mode
		while(!(sta & 0x04)){			//wait for valid pressure data
			sta = MPL_Read_MPL_reg(0);//Read the status register
		}
		HAL_I2C_Mem_Read(&hi2c1, _SlaveA, 0x01, I2C_MEMADD_SIZE_8BIT, _SensorData, 3,1000);
		return((((_SensorData[2]>>4)/128.0)+ (_SensorData[0]*256 +_SensorData[1]))*3.28);
	}

	float MPL_Altitude_m (void)	//Return Altitude in meters
	{
		uint8_t sta = 0;
		while (MPL_Read_MPL_reg(0x26) & 0x02) HAL_Delay(10);// Read the ost bit
		MPL_Write_Register(0x26,0xBA);  //initiate a measurement immediately in Altimeter mode
		while(!(sta & 0x04)){			//wait for valid pressure data
			sta = MPL_Read_MPL_reg(0);//Read the status register
		}
		HAL_I2C_Mem_Read(&hi2c1, _SlaveA, 0x01, I2C_MEMADD_SIZE_8BIT, _SensorData, 3,1000);
		return((((_SensorData[2]>>4)/128.0)+ (_SensorData[0]*256 +_SensorData[1])));
	}

	float MPL_Temp_F (void)		//Return Temp in Degrees F
	{
		uint8_t sta = 0;
		while (MPL_Read_MPL_reg(0x26) & 0x02) HAL_Delay(10);// Read the ost bit
		MPL_Write_Register(0x26,0x3A);  //initiate a measurement immediately in barometer mode
		while(!(sta & 0x04)){			//wait for valid pressure data
			sta = MPL_Read_MPL_reg(0);//Read the status register
		}
		HAL_I2C_Mem_Read(&hi2c1, _SlaveA, 0x04, I2C_MEMADD_SIZE_8BIT, _SensorData, 2,1000);
		return(((_SensorData[1]>>4)/128.0+(float)_SensorData[0])*(1.8)+32.0);
	}

	float MPL_Temp_C (void)		//Return Temp in Degrees C
	{
		uint8_t sta = 0;
		while (MPL_Read_MPL_reg(0x26) & 0x02) HAL_Delay(10);// Read the ost bit
		MPL_Write_Register(0x26,0x3A);  //initiate a measurement immediately in barometer mode
		while(!(sta & 0x04)){			//wait for valid pressure data
			sta = MPL_Read_MPL_reg(0);//Read the status register
		}
		HAL_I2C_Mem_Read(&hi2c1, _SlaveA, 0x04, I2C_MEMADD_SIZE_8BIT, _SensorData, 2,1000);
		return(((_SensorData[1]>>4)/128.0+(float)_SensorData[0]));
	}

	int MPL_Init (void)			//Initialize the MPL3115A2 in Alitude Interrupt Mode
	{
		  int status = -1;
	   /* status = MPL_Write_Register(0x26,0x38);

			if(status==0)
			{
				status = -1;
				status = MPL_Write_Register(0x13,0x0);
			}

			if(status==0)
			{
				status = -1;
				status = MPL_Write_Register(0x2d,OFFSET);
			}

			if(status==0)
			{
				status = -1;
				status = MPL_Write_Register(0x28,0x11);
			}

			if(status==0)
			{
				status = -1;
				status = MPL_Write_Register(0x29,0x0);
			}

			if(status==0)
			{
				status = -1;
				status = MPL_Write_Register(0x26,0x39);
			}*/
		  // *** Reset all register
		  status = MPL_Write_Register(0x26,0x04);
		  HAL_Delay(10);
		  while (MPL_Read_MPL_reg(0x26) & 0x04) HAL_Delay(10);
		  status = MPL_Write_Register(0x26,0x38);// Barometer mode max resolution
		  status = MPL_Write_Register(0x13,0x07);


 	    return(status);

	}





