#ifndef _VEML6070_H_
#define _VEML6070_H_

#define VEML6070_ADDR_ARA (0x18)
#define VEML6070_ADDR_CMD (0x70)
#define VEML6070_ADDR_DATA_LSB (0x71)
#define VEML6070_ADDR_DATA_MSB (0x73)
// VEML6070 command register bits
#define VEML6070_CMD_SD 0x01
#define VEML6070_CMD_IT_0_5T 0x00
#define VEML6070_CMD_IT_1T 0x04
#define VEML6070_CMD_IT_2T 0x08
#define VEML6070_CMD_IT_4T 0x0C
#define VEML6070_CMD_DEFAULT 0x0E	// for 2T integration time

typedef enum {LOW, MODERATE, HIGH, VERY_HIGH, EXTREME} RISK_LEVEL;
uint8_t cmd ;
uint16_t uvs_step;
RISK_LEVEL risk_level;

void initialize_VEML6070(void);
void enable_sensor(void);
void disable_sensor(void);
uint16_t read_uvs_step(void);
RISK_LEVEL convert_to_risk_level(uint16_t uvs_step);
int VEML6070_read_byte(uint16_t addr, uint8_t *data);
int VEML6070_write_byte(uint16_t addr, uint8_t *data);

#endif
