/*
 * GPS.h
 *
 *  Created on: 14 oct. 2019
 *      Author: Dominique
 */

#ifndef GPS_H_
#define GPS_H_
#include <stdint.h>

//##################################################################################################################

typedef struct
{
	float			UTC_Time;
	uint8_t			UTC_Hour;
	uint8_t			UTC_Min;
	uint8_t			UTC_Sec;
	uint16_t		UTC_MicroSec;

	uint32_t		gps_date;
	uint8_t			gps_day;
	uint8_t			gps_month;
	uint8_t			gps_year;

	float				Latitude;
	double			LatitudeDecimal;
	char				NS_Indicator;
	float				Longitude;
	double			LongitudeDecimal;
	char				EW_Indicator;

	uint8_t			PositionFixIndicator;
	uint8_t			SatellitesUsed;
	float				HDOP;
	float				MSL_Altitude;
	char				status;
	float				Geoid_Separation;
	//char				Geoid_Units;

	//uint16_t		AgeofDiffCorr;
	//char				DiffRefStationID[4];
	//char				CheckSum[2];

}GPGGA_t;

typedef struct
{
	uint8_t		rxBuffer[512];
	uint16_t	rxIndex;
	uint8_t		rxTmp;
	uint32_t	LastTime;

	GPGGA_t		GPGGA;

}GPS_t;

extern GPS_t GPS;
//##################################################################################################################
void	GPS_Init(void);
void	GPS_CallBack(void);
void	GPS_Process(void);
//##################################################################################################################



#endif /* GPS_H_ */
