/*
 * MPL311A2.c
 *
 *  Created on: 22 sept. 2019
 *      Author: Dominique
 */


#include "MPL3115A2.h"

	uint16_t _SlaveA = 0xC0;	//local variable that holds the Slave Address
	uint8_t _SensorData[8];  	//Char array that holds the current Altitude and Temperature data
	I2C_HandleTypeDef hi2c1;

	int MPL_Write_Register (uint8_t regnum, uint8_t data)   //Used for writing data to the MPL3115A2 Registers
	{
		uint8_t Write_Data[2];
		Write_Data[0] = regnum;
		Write_Data[1] = data;
		return(HAL_I2C_Master_Transmit(&hi2c1, _SlaveA, Write_Data, 2, 1000));
	}

	int MPL_Read_MPL_Data(void)		//Read Data Register from MPL3115A2 Sensor
	{
		uint16_t Start_Register = {0x01};
		return(HAL_I2C_Mem_Read(&hi2c1, _SlaveA, Start_Register, I2C_MEMADD_SIZE_8BIT, _SensorData, 5,1000));

	}

	/*bool MPL_get_int1 (void)   //Return state of Int1 pin
	{
		return(_pin1.read());
	}

	bool MPL_get_int2 ()	  //Return state of Int2 pin
	{
		return(_pin2.read());
	}*/
	float MPL_Pressure(void) //Return Pressure in Pascal
	{
		return((((_SensorData[2]>>6)/4.0) + (_SensorData[0]*1024 + _SensorData[1])));
	}
	float MPL_Altitude_ft (void) //Return Altitude in Feet
	{
		return((((_SensorData[2]>>4)/128.0)+ (_SensorData[0]*256+_SensorData[1]))*3.28);
	}

	float MPL_Altitude_m (void)	//Return Altitude in meters
	{
		return((((_SensorData[2]>>4)/128.0)+ (_SensorData[0]*256+_SensorData[1])));
	}

	float MPL_Temp_F (void)		//Return Temp in Degrees F
	{
		return(((_SensorData[4]>>4)/128.0+(float)_SensorData[3])*(1.8)+32.0);
	}

	float MPL_Temp_C (void)		//Return Temp in Degrees C
	{
		return(((_SensorData[4]>>4)/128.0+(float)_SensorData[3]));
	}

	int MPL_Init (void)			//Initialize the MPL3115A2 in Alitude Interrupt Mode
	{
		  int status = -1;
	    status = MPL_Write_Register(0x26,0x38);

			if(status==0)
			{
				status = -1;
				status = MPL_Write_Register(0x13,0x0);
			}

			if(status==0)
			{
				status = -1;
				status = MPL_Write_Register(0x2d,OFFSET);
			}

			if(status==0)
			{
				status = -1;
				status = MPL_Write_Register(0x28,0x11);
			}

			if(status==0)
			{
				status = -1;
				status = MPL_Write_Register(0x29,0x0);
			}

			if(status==0)
			{
				status = -1;
				status = MPL_Write_Register(0x26,0x39);
			}
 	    return(status);

	}





